import { ParallelStructure, StructureType } from "jalhyd";
import { SelectField } from "./select-field";
import { SelectEntry } from "./select-entry";
import { FormulaireNode } from "../formulaire-node";

/*
    "id": "select_structure",
    "type": "select",
    "property": "structureType",
    "source": "device_structure_type"
*/

export class SelectFieldDeviceStructureType extends SelectField {
    constructor(parent: FormulaireNode) {
        super(parent);
        this._associatedProperty = "structureType";
    }

    public parseConfig(json: {}, data?: {}) {
        super.parseConfig(json, data);
        this._configDefaultValue = json["default"];
    }

    protected populate() {
        // possible values depend on CalcType
        for (const st in (this.nub as ParallelStructure).getLoisAdmissibles()) {
            const e: SelectEntry = new SelectEntry(this._entriesBaseId + st, StructureType[st]);
            this.addEntry(e);
        }
    }

    protected initSelectedValue() {
        this.findAndSetDefaultValue();
    }
}
